<template lang="pug">
q-card.my-card.relative(flat, bordered)
  q-card-section.bg-warning.q-pa-sm(
    v-if="call.error || call.unallocated",
    horizontal
  )
    div {{ call.error ? call.error : `${call.unallocated} sensors were not allocated due to resource limits` }}

  q-card-section(horizontal)
    q-card-section.col
      .row.items-start
        BasicCallDetails(:call="call")
        q-space
        q-btn.col-auto.q-ml-sm.self-start(
          v-if="allowEditingOrDeleting || allowDownloadMeetingData",
          flat,
          round,
          icon="more_vert"
        )
          q-menu(anchor="center middle")
            q-list
              q-item(
                v-if="allowEditingOrDeleting",
                clickable,
                @click="requestEditDocs",
                v-close-popup
              )
                q-item-section(avatar)
                  q-icon(name="description", color="primary", size="medium")
                q-item-section Prepare Docs
              q-item(
                v-if="allowEditingOrDeleting",
                clickable,
                @click="requestCancel",
                v-close-popup
              )
                q-item-section(avatar)
                  q-icon(name="delete", color="primary", size="medium")
                q-item-section Delete ZoomSense Meeting
              q-item(
                v-if="allowEditingOrDeleting",
                clickable,
                @click="requestEditSensorCount",
                v-close-popup
              )
                q-item-section(avatar)
                  q-icon(name="edit", color="primary", size="medium")
                q-item-section Edit ZoomSensor count
              q-item(
                v-if="allowDownloadMeetingData",
                clickable,
                @click="requestDownloadMeetingData",
                v-close-popup
              )
                q-item-section(avatar)
                  q-icon(
                    name="fas fa-download",
                    color="primary",
                    size="medium"
                  )
                q-item-section Download JSON Data
    q-separator(vertical)

    q-card-actions.justify-around.q-px-md(vertical)
      q-btn(
        :disable="!Running || call.deleted !== undefined",
        flat,
        round,
        color="primary",
        icon="voice_chat",
        @click="openzoom()"
      )
        q-tooltip Join class
      q-btn(
        :disable="!call.scheduled || !Started || call.deleted !== undefined",
        flat,
        round,
        color="red",
        icon="pie_chart",
        :to="'/' + callKey"
      )
        q-tooltip View visualisations
      q-btn(
        :loading="getLinkLoading",
        :disable="Anonymous || getLinkLoading || call.deleted !== undefined",
        flat,
        round,
        color="secondary",
        icon="share",
        @click="getShareLink()"
      )
        q-tooltip Share this class visualisation

  q-dialog(v-model="shareCard")
    q-card.share-card
      q-card-section.col.items-center
        .text-h6 {{ tokenSuccess ? 'Successfully Copied Share Link' : 'Copy and Share the Following Link' }}
        span Share this link with someone to give them read-only access to this class dashboard.
        q-input(readonly, :value="token")
      q-card-actions(align="right")
        q-btn(flat, label="OK", color="primary", v-close-popup)

  q-dialog(v-model="editingSensorCount", @hide="resetEditingSensorValue")
    q-card(title="Sensors", style="min-width: 40%")
      q-inner-loading(:showing="loadingRequestDifferentNumberOfSensors", dark)
        q-spinner(color="white", size="xl")
      q-form(@submit="updateSensorCount")
        q-card-section Editing Sensor Count
          q-input(
            type="number",
            ref="editingSensorCountInputRef",
            v-model="editingSensorCountValue",
            :rules="[val => val.length || 'Sensor count cannot be empty', val => parseInt(val) > 0 || 'Sensor count must be positive']"
          )
        q-card-actions(align="right")
          q-btn(label="Ok", type="submit", flat, color="primary")
</template>

<script>
import moment from "moment-timezone";
import { config, db, functions, auth } from "../db";
const generateLink = functions.httpsCallable("generateLink");
var timezone = moment.tz.guess();
import ErrorHandler from "../mixins/ErrorHandler";
import { download } from "../shared";
import BasicCallDetails from "./BasicCallDetails.vue";

export default {
  name: "ScheduledCall",
  props: ["call", "callKey"],
  mixins: [ErrorHandler],
  data: function () {
    return {
      noOfBreakoutRooms: 2,
      loading: false,
      shareCard: false,
      capacity: 0,
      token: null,
      tokenSuccess: true,
      requestLoading: false,
      getLinkLoading: false,
      currentToSchedule: 0,
      currentScheduled: 0,
      loadingRequestDifferentNumberOfSensors: false,
      editingSensorCountValue: this.call.noOfBreakoutRooms,
      editingSensorCount: false,
      editingSensorCountInputRef: null,
    };
  },
  computed: {
    duration() {
      return moment
        .duration(moment(this.call.endTime).diff(moment(this.call.startTime)))
        .humanize();
    },
    docsCreated() {
      if (this.call.gdocs && this.call.gdocs.documents) {
        return Object.keys(this.call.gdocs.documents).length;
      } else return 0;
    },
    startFull() {
      return moment(this.call.startTime)
        .tz(timezone)
        .format("Do MMMM YYYY \\a\\t h:mma (z)");
    },
    startLess() {
      return moment(this.call.startTime)
        .tz(timezone)
        .format("Do MMMM \\a\\t h:mma");
    },
    RequestButtonString() {
      return this.loading ? "Please wait..." : "Request ZoomSense";
    },
    Running() {
      return moment().isBetween(this.call.startTime, this.call.endTime);
    },
    Started() {
      return moment(this.call.startTime) < moment().utc();
    },
    Finished() {
      return moment(this.call.endTime) <= moment().utc();
    },
    Ongoing() {
      return this.Started && !this.Finished;
    },
    Soon() {
      return (
        !this.Started &&
        moment
          .duration(moment(this.call.startTime).diff(moment().utc()))
          .as("minutes") < 60
      );
    },
    Anonymous() {
      const anonymous = this.$cookies.get("anonymous");
      return anonymous ? true : false;
    },
    StartTime() {
      var start = moment(this.call.startTime);
      var finish = moment(this.call.endTime);

      if (!this.Started) {
        return start.tz(timezone).toNow();
      } else if (this.Finished) {
        // meeting has finished
        return (
          start.tz(timezone).format("Do MMMM YYYY, HH:mma") +
          " - " +
          finish.tz(timezone).format("HH:mma")
        );
      }
      // ongoing
      return "Started " + start.tz(timezone).fromNow();
    },
    allowEditingOrDeleting() {
      return !this.call.scheduled && !this.Started;
    },
    allowDownloadMeetingData() {
      return Boolean(this.call.actualEndTime);
    },
  },
  methods: {
    testRule(val) {
      console.log(val);
      return val.length > 0;
    },
    openzoom() {
      if (this.Running)
        window.location = "zoommtg://zoom.us/join?confno=" + this.callKey;
    },
    async getShareLink() {
      try {
        this.getLinkLoading = true;
        // Read result of the generateLink Function
        const result = await generateLink({
          meetingid: this.callKey,
          hostuid: auth.currentUser.uid,
        });
        this.token = `${process.env.VUE_APP_REDIRECT}/#/anonymous?token=${result.data}`;
        this.$copyText(this.token).then(
          () => {
            // Copy successful
            this.tokenSuccess = true;
          },
          () => {
            // Copy failed
            this.tokenSuccess = false;
          },
        );
        this.getLinkLoading = false;
        this.shareCard = true;
      } catch (error) {
        console.log("Error " + error.code + ": " + error.message);
        return this.$router.push("/");
      }
    },
    async requestCancel() {
      // Can't cancel scheduled or started calls, or calls that don't exist yet
      if (this.call.scheduled || this.Started) return;
      this.$q
        .dialog({
          title: "Are you sure you want to Delete this ZoomSense meeting?",
          cancel: {
            color: "grey",
            flat: true,
          },
          ok: {
            label: "Delete",
            color: "negative",
            flat: true,
          },
        })
        .onOk(() => {
          db.ref(`/meetings/${auth.currentUser.uid}/${this.callKey}`).remove();
        });
    },
    viewMeetingDetails: function () {
      this.$router.push("/" + this.callKey);
    },
    async updateSensorCount() {
      this.loadingRequestDifferentNumberOfSensors = true;
      (async () => {
        const requestedSensorCount = parseInt(this.editingSensorCountValue);

        if (Number.isNaN(requestedSensorCount) || requestedSensorCount < 1) {
          throw new Error(
            "updateSensorCount called with negative / non number",
          );
        }

        const capacity = (
          await this.$http
            .post(`${config.functions_url}/getMeetingCapacityManual`, {
              duration: moment
                .duration(
                  moment(this.call.endTime).diff(moment(this.call.startTime)),
                )
                .asMinutes(),
              start_time: this.call.startTime,
            })
            .catch(() => {
              throw new Error(
                "Error fetching the sensor capacity for this time",
              );
            })
        ).data.capacity;

        if (capacity + this.call.noOfBreakoutRooms < requestedSensorCount) {
          this.$q.notify({
            type: "negative",
            message: `Invalid Sensor count! Can't have more than ${
              this.call.noOfBreakoutRooms + capacity
            }`,
            actions: [
              {
                label: "Autofill",
                color: "yellow",
                handler: () => {
                  this.editingSensorCountValue = `${
                    this.call.noOfBreakoutRooms + capacity
                  }`;
                },
              },
            ],
          });
          throw undefined;
        }

        const editMeeting = functions.httpsCallable("editZoomSenseMeeting");

        await editMeeting({
          noOfBORooms: requestedSensorCount,
          meetingKey: this.callKey,
        }).catch(e => {
          throw new Error(e.message || "Error updating the sensor count");
        });
      })()
        .then(() => (this.editingSensorCount = false))
        .catch(
          e =>
            e !== undefined &&
            this.$q.notify({ type: "negative", message: `${e}` }),
        )
        .finally(() => (this.loadingRequestDifferentNumberOfSensors = false));
    },
    async requestEditSensorCount() {
      console.log(this.call);
      this.resetEditingSensorValue();
      this.editingSensorCount = true;
    },
    resetEditingSensorValue() {
      this.editingSensorCountValue = String(this.call.noOfBreakoutRooms);
    },
    async requestDownloadMeetingData() {
      console.log("Requested Download Data");
      console.log(this.callKey);
      const chats = (
        await db.ref(`data/chats/${this.callKey}`).once("value")
      ).val();
      const activeSpeakers = (
        await db.ref(`data/activeSpeakers/${this.callKey}`).once("value")
      ).val();
      download(
        `${this.call.topic}.json`,
        JSON.stringify({ chats, activeSpeakers }, null, 4),
      );
    },
    requestEditDocs() {
      this.$router.push(`managedocs/${this.callKey}`);
    },
  },
  components: {
    BasicCallDetails,
  },
};
</script>

<style scoped>
.vspace1 {
  line-height: 2em;
}

.my-card {
  text-align: left;
  overflow: hidden;
}

.breakoutInput {
  width: 50px;
  margin-bottom: 8px;
}

.soon {
  color: red;
}

.started {
  color: green;
}

.avatar {
  font-size: 2rem;
}

/* .share-card {
  padding-left: 10px;
  padding-right: 30px;
} */

.analytics-button {
  margin-top: 10px;
}
</style>
